
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>HTTP协议及其POST与GET操作差异 &amp; C#中如何使用POST、GET等 / iVAN</title>

    <meta name="description" content="HTTP协议及其POST与GET操作差异 &amp; C#中如何使用POST、GET等 引言 HTTP协议我想任何IT人士都耳熟能详了,大家都能说出个所以然来.但是如果我问你 HTTP协议的请求方法有哪些?POST与GET的差异?GET或POST传送数据量的大小有限制吗?HTTP响应的状态有哪些?以及在C#中你如何使 用?如果你不能清楚地回答其中的大部分问题,那么这篇文章就是为你准备的!大纲如下: 1.HTTP概述 1.1.HTTP协议的客户端与服务器的交互 1.2.HTTP消息 1.3.HTTP请求的方法 1.4.HTTP响应的代码 2.抓包分析 3.POST与GET的差异 4.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">HTTP协议及其POST与GET操作差异 &amp; C#中如何使用POST、GET等</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h4><strong>引言</strong></h4>
<p>HTTP协议我想任何IT人士都耳熟能详了，大家都能说出个所以然来。但是如果我问你<br />
HTTP协议的请求方法有哪些？POST与GET的差异？GET或POST传送数据量的大小有限制吗？HTTP响应的状态有哪些？以及在C#中你如何使<br />
用？如果你不能清楚地回答其中的大部分问题，那么这篇文章就是为你准备的！大纲如下：</p>
<ul>
<li>1、HTTP概述
<ul>
<li>1.1、HTTP协议的客户端与服务器的交互</li>
<li>1.2、HTTP消息</li>
<li>1.3、HTTP请求的方法</li>
<li>1.4、HTTP响应的代码</li>
</ul>
</li>
<li>2、抓包分析</li>
<li>3、POST与GET的差异</li>
<li>4、以一个实例说明C#中如何使用POST、GET等操作
<ul>
<li>4.1、HttpWebRequest</li>
<li>4.2、HttpWebResponse</li>
<li>4.3、编写WinForm程序打开博客园首页（附源码）</li>
</ul>
</li>
</ul>
<h4><strong>1、HTTP概述</strong></h4>
<p>为了唤醒你对HTTP协议的记忆或使你能够对HTTP协议有所了解，首先简单一下HTTP协议。<strong>超文本传输协议</strong>（<strong>HTTP</strong>，<em>HyperText Transfer Protocol</em>）是<a href="http://zh.wikipedia.org/zh-cn/%E7%B6%B2%E9%9A%9B%E7%B6%B2%E8%B7%AF" rel="external nofollow noreferrer">互联网</a>上应用最为广泛的一种<a href="http://zh.wikipedia.org/zh-cn/%E7%BD%91%E7%BB%9C%E5%8D%8F%E8%AE%AE" rel="external nofollow noreferrer">网络协议</a>。所有的<a href="http://zh.wikipedia.org/zh-cn/WWW" rel="external nofollow noreferrer">WWW</a>文件都必须遵守这个标准。设计HTTP最初的目的是为了提供一种发布和接收<a href="http://zh.wikipedia.org/zh-cn/HTML" rel="external nofollow noreferrer">HTML</a>页面的方法。</p>
<p>HTTP的发展是万维网协会（<a href="http://zh.wikipedia.org/zh-cn/World_Wide_Web_Consortium" rel="external nofollow noreferrer">World Wide Web Consortium</a>）和Internet工作小组（<a href="http://zh.wikipedia.org/zh-cn/Internet_Engineering_Task_Force" rel="external nofollow noreferrer">Internet Engineering Task Force</a>）合作的结果，（他们）最终发布了一系列的<a href="http://zh.wikipedia.org/zh-cn/RFC" rel="external nofollow noreferrer">RFC</a>，其中最著名的就是<a href="http://tools.ietf.org/html/rfc2616" rel="external nofollow noreferrer">RFC 2616</a>。<a href="http://tools.ietf.org/html/rfc2616" rel="external nofollow noreferrer">RFC 2616</a>定义了HTTP协议中一个现今被广泛使用的版本——HTTP 1.1。</p>
<h4><strong>1.1、HTTP协议的客户端与服务器的交互</strong></h4>
<p>HTTP是一个客户端和服务器端请求和应答的标准（<a href="http://zh.wikipedia.org/zh-cn/TCP" rel="external nofollow noreferrer">TCP</a>）。<strong>客户端是终端用户</strong>，<strong>服务器端是网站</strong>。通过使用Web浏览器、网络爬虫或者其它的工具，客户端发起一个到服务器上指定端口（默认<a href="http://zh.wikipedia.org/zh-cn/%E7%AB%AF%E5%8F%A3" rel="external nofollow noreferrer">端口</a>为<br />
80）的HTTP请求。（我们称这个客户端）调用户代理（user<br />
agent）。应答的服务器上存储着（一些）资源，比如HTML文件和图像。（我们称）这个应答服务器为源服务器（origin<br />
server）。在用户代理和源服务器中间可能存在多个中间层，比如代理，网关，或者隧道（tunnel）。尽管<a href="http://zh.wikipedia.org/zh-cn/TCP/IP" rel="external nofollow noreferrer">TCP/IP</a>协议是互联网上最流行的应用，HTTP协议并没有规定必须使用它和（基于）它支持的层。事实上，HTTP可以在任何其他互联网协议上，或者在其他网络上实现。HTTP只假定（其下层协议提供）可靠的传输，任何能够提供这种保证的协议都可以被其使用。</p>
<p><strong>通<br />
常，由HTTP客户端发起一个请求，建立一个到服务器指定端口（默认是80端口）的TCP连接。HTTP服务器则在那个端口监听客户端发送过来的请求。一<br />
旦收到请求，服务器（向客户端）发回一个状态行，比如"HTTP/1.1 200<br />
OK"，和（响应的）消息，消息的消息体可能是请求的文件、错误消息、或者其它一些信息。</strong></p>
<p>HTTP使用TCP而不是UDP的原因在于（打开一个）一个网页必须传送很多数据，而<a href="http://zh.wikipedia.org/zh-cn/TCP" rel="external nofollow noreferrer">TCP</a>协议提供传输控制，按顺序组织数据，和错误纠正。通过HTTP或者HTTPS协议请求的<strong>资源由统一资源标识符</strong>（Uniform Resource Identifiers，或者，更准确一些，URI）来标识。</p>
<p>客户端与服务器端的结构与交互过程可以表示为下面2张图：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/HTTP_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L0hUVFBfdGh1bWIucG5n.jpg"></a> 图1、Web客户端-服务器端结构（其中web服务器的超文本链接，即通过网站上的一个链接跳转到了其他服务器上）</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/image_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L2ltYWdlX3RodW1iLnBuZw==.jpg"></a>图2、Web客户端与服务器端的交互</p>
<h4><strong>1.2、HTTP消息</strong></h4>
<p>客户端与服务器之间的交互用到了两种类型的消息：<strong>请求（Request）</strong>和<strong>响应（Response）</strong>。</p>
<p>HTTP请求的格式为：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L0hUVFAlRTglQUYlQjclRTYlQjElODJfdGh1bWJfMi5qcGc=.jpg"></p>
<p>  图3、HTTP请求的格式</p>
<p>HTTP响应的格式为：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/HTTP%E5%93%8D%E5%BA%94_6.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L0hUVFAlRTUlOTMlOEQlRTUlQkElOTRfdGh1bWJfMi5qcGc=.jpg"></a></p>
<p>图4、HTTP响应的格式</p>
<p>从上面可以看出HTTP的请求和响应消息的首部均包含可变数量的字段，用一个空行（<em>blank line</em>）将所有<strong>首部字段</strong>（header）与<strong>消息主体</strong>（body）分隔开来。<strong>一个首部字段由字段名和随后的冒号、一个空格和字段值组成，字段名不区分大小写</strong>。</p>
<p>报文头可分为三类：一类应用于请求，一类应用于响应，还有一类描述主体。有一些报文头（例如：Date）既可用于请求又可用于响应。描述主体的报文头可以出现在POST请求和所有响应报文中。HTTP的首部字段如下图所示：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/HTTP%20header_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L0hUVFAlMjBoZWFkZXJfdGh1bWIucG5n.jpg"></a></p>
<p>图5、HTTP首部字段</p>
<h4><strong>1.3、HTTP请求的方法</strong></h4>
<p>HTTP/1.1协议中共定义了八种方法（有时也叫“动作”）来表明<em>Request-URI</em>指定的资源的不同操作方式：</p>
<ul>
<li>OPTIONS <br />
返回服务器针对特定资源所支持的HTTP请求方法。也可以利用向Web服务器发送'*'的请求来测试服务器的功能性。</li>
<li>HEAD <br />
向服务器索要与GET请求相一致的响应，只不过响应体将不会被返回。这一方法可以在不必传输整个响应内容的情况下，就可以获取包含在响应消息头中的元信息。</li>
<li>GET <br />
向特定的资源发出请求。注意：GET方法不应当被用于产生“副作用”的操作中，例如在<a href="http://zh.wikipedia.org/zh-cn/%E7%B6%B2%E9%A0%81%E6%87%89%E7%94%A8%E7%A8%8B%E5%BC%8F" rel="external nofollow noreferrer">Web Application</a>中。其中一个原因是GET可能会被<a href="http://zh.wikipedia.org/zh-cn/%E7%BD%91%E7%BB%9C%E8%9C%98%E8%9B%9B" rel="external nofollow noreferrer">网络蜘蛛</a>等随意访问。</li>
<li>POST <br />
向指定资源提交数据进行处理请求（例如提交表单或者上传文件）。数据被包含在请求体中。POST请求可能会导致新的资源的建立和/或已有资源的修改。</li>
<li>PUT <br />
向指定资源位置上传其最新内容。</li>
<li>DELETE <br />
请求服务器删除<em>Request-URI</em>所标识的资源。</li>
<li>TRACE <br />
回显服务器收到的请求，主要用于测试或诊断。</li>
<li>CONNECT <br />
HTTP/1.1协议中预留给能够将连接改为管道方式的代理服务器。</li>
</ul>
<p>方法名称是区分大小写的。当某个请求所针对的资源不支持对应的请求方法的时候，服务器应当返回状态码405（Method Not Allowed）；当服务器不认识或者不支持对应的请求方法的时候，应当返回状态码501（Not Implemented）。</p>
<p>HTTP服务器至少应该实现GET和HEAD方法，其他方法都是可选的。此外，除了上述方法，特定的HTTP服务器还能够扩展自定义的方法。</p>
<blockquote><h6><strong>安全方法</strong></h6>
<p>开发者应当意识到他们的<a href="http://zh.wikipedia.org/zh-cn/%E8%BD%AF%E4%BB%B6" rel="external nofollow noreferrer">软件</a>代表了用户在<a href="http://zh.wikipedia.org/zh-cn/%E5%9B%A0%E7%89%B9%E7%BD%91" rel="external nofollow noreferrer">因特网</a>上进行交互，并且应当告知用户，他们正在进行的操作可能对他们自身或者其他人有未曾预料的重要影响。</p>
<p>特别地，对于GET和HEAD方法而言，除了进行获取资源信息外，这些请求不应当再有任何其他意义。也就是说，这些方法应当被认为是“安全的”，即<strong>所谓安全的意味着该操作用于获取信息而非修改信息</strong>。客户端应当使用其他“非安全”方法，例如POST、PUT及DELETE来以特殊的方式（通常是按钮而不是<a href="http://zh.wikipedia.org/zh-cn/%E8%B6%85%E9%93%BE%E6%8E%A5" rel="external nofollow noreferrer">超链接</a>）使得客户能够意识到可能要负的责任（例如一个按钮带来的资金交易）或者被告知正在请求的操作可能是不安全的（例如某个文件将被上传或删除）。</p>
<p>但是，不能想当然地认为服务器不会在处理某个GET请求时不会产生任何副作用。事实上，很多动态资源会把这作为其特性。这里重要的区别在于用户并没有请求这一副作用，因此不应由用户为这些副作用承担责任。</p>
<h6><strong>幂等方法</strong></h6>
<p>假<br />
如在不考虑诸如错误或者过期等问题的情况下，若干次请求的副作用与单次请求相同或者根本没有副作用，那么这些请求方法就能够被视作“幂等”的。<br />
GET，HEAD，PUT和DELETE方法都有这样的幂等属性，同样由于根据协议，OPTIONS，TRACE都不应有副作用，因此也理所当然也是幂等<br />
的。</p>
<p>假如某个由若干个请求做成的请求串行产生的结果在重复执行这个请求串行或者其中任何一个或多个请求后仍没有发生变化，则这个请求串行<br />
便是“幂等”<br />
的。但是，可能出现若干个请求做成的请求串行是“非幂等”的，即使这个请求串行中所有执行的请求方法都是幂等的。例如，这个请求串行的结果依赖于某个会在<br />
下次执行这个串行的过程中被修改的变量。</p></blockquote>
<h4><strong>1.4、HTTP响应的代码</strong></h4>
<p> 服务器程序响应的第一行叫状态行。状态行以HTTP版本号开始，后面跟着3位数字表示响应代码，最后是易读的响应短语。根据第一位可以把响应分成5类：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/HTTP%E5%93%8D%E5%BA%94%E4%BB%A3%E7%A0%81_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L0hUVFAlRTUlOTMlOEQlRTUlQkElOTQlRTQlQkIlQTMlRTclQTAlODFfdGh1bWIucG5n.jpg"></a></p>
<p>图6、HTTP响应代码</p>
<h4><strong>2、抓包分析</strong></h4>
<p>现在我们对HTTP基本上算是了解了，下面我用wireshark抓取打开博客园首页时，我的电脑与博客园服务器的交互过程的HTTP数据包。做好准备工作，关闭一些可能干扰我们抓取打开博客园的相关程序。如下图，我们在浏览器中输入<a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">www.cnblogs.com</a>并确定时，首先抓到如下包：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/wireshark1_4.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L3dpcmVzaGFyazFfdGh1bWJfMS5wbmc=.jpg"></a></p>
<p>  图7、打开博客园抓取的包</p>
<p>从图中可以看出，我们在浏览器中输入<a href="http://www.cnblogs.com/" rel="external nofollow noreferrer">www.cnblogs.com</a>并确定时是向服务器发送了一个HTTP请求消息：GET  /  HTTP/1.1。根据1.2中介绍的HTTP消息的格式，我们知道GET对应<em>request</em>、/对应<em>request-line</em>、HTTP/1.1对应<em>版本号</em>。除了请求行之外，发送了一些首部字段，如：Accept、Accept-Language、User-Agent、Accept-Encoding、Host、Connection等。而且可以看出他们的格式就是：<strong>首部字段名: 字段值</strong>，注意冒号后面有个空格。</p>
<p>接下来我们看一下GET  /  HTTP/1.1请求的响应消息是怎样的：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/wireshark2_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L3dpcmVzaGFyazJfdGh1bWIucG5n.jpg"></a> 图8、GET  /  HTTP/1.1请求的响应消息</p>
<p>响应消息的状态行是：HTTP/1.1  200  OK，其中HTTP/1.1对<em>应版本号</em>、200对应<em>response-code</em>、OK对应<em>response-phrase</em>。除了状态行，还返回了一些首部字段，如：Cache-Control、Content-Type、Content-Encoding、Expires、Last-Modified、Vary、Server等等。（通过上图我们可以看出，博客用的是IIS7.0）</p>
<p>上面抓的是GET的数据包，现在我来看一个POST的数据包——打开博客园首页过程中获取左边的分类信息就是通过POST请求返回的。</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/wireshark3_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L3dpcmVzaGFyazNfdGh1bWIucG5n.jpg"></a></p>
<p>图9、POST数据包</p>
<p>我们可以看到，POST /ws/PublicUserService.asmx/GetLoginInfo HTTP/1.1。除了把GET换成了POST之外，其它信息差不多。下面我们放大看下发送的首部字段：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/wireshark4_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L3dpcmVzaGFyazRfdGh1bWIucG5n.jpg"></a> 图10、POST /ws/PublicUserService.asmx/GetLoginInfo HTTP/1.1的首部字段</p>
<p>NOTE：本节涉及的一些首部字段我就不在这里解释了。我想，到了这里大家对HTTP的认识应该更深入了一步。</p>
<h4><strong>3、POST与GET的差异</strong></h4>
<p>1.3中介绍了8种方法，其中GET与POST最基本和常用了。表单提交中get和post方式的区别归纳如下几点：</p>
<ul>
<li>GET是从服务器上获取数据，POST是向服务器传送数据。</li>
<li>GET<br />
是把参数数据队列加到提交表单的ACTION属性所指的URL中，值和表单内各个字段一一对应，在URL中可以看到。POST是通过HTTP<br />
POST机制，将表单内各个字段与其内容放置在HTML HEADER内一起传送到ACTION属性所指的URL地址。用户看不到这个过程。</li>
<li>对于GET方式，服务器端用Request.QueryString获取变量的值，对于POST方式，服务器端用Request.Form获取提交的数据。</li>
<li>GET传送的数据量较小，不能大于2KB（这主要是因为受URL长度限制）。POST传送的数据量较大，一般被默认为不受限制。但理论上，限制取决于服务器的处理能力。</li>
<li>GET<br />
安全性较低，POST安全性较高。因为GET在传输过程，数据被放在请求的URL中，而如今现有的很多服务器、代理服务器或者用户代理都会将请求URL记<br />
录到日志文件中，然后放在某个地方，这样就可能会有一些隐私的信息被第三方看到。另外，用户也可以在浏览器上直接看到提交的数据，一些系统内部消息将会一<br />
同显示在用户面前。POST的所有操作对用户来说都是不可见的。</li>
</ul>
<p>在FORM提交的时候，如果不指定Method，则默认为<br />
GET请求（.net默认是POST），Form中提交的数据将会附加在url之后，以?分开与url分开。字母数字字符原样发送，但空格转换为“+”<br />
号，其它符号转换为%XX,其中XX为该符号以16进制表示的ASCII（或ISO Latin-1）值。<strong>GET请求请提交的数据放置在HTTP请求协议头中，而POST提交的数据则放在实体数据中；GET方式提交的数据最多只能有2048字节，而POST则没有此限制</strong>。POST传递的参数在doc里，也就http协议所传递的文本，接受时再解析参数部分。获得参数。一般用POST比较好。POST提交数据是隐式的，GET是通过在url里面传递的，用来传递一些不需要保密的数据，GET是通过在URL里传递参数，POST不是。</p>
<p>说明：关于“POST与GET的差异”查考了网上前辈的资料，由于找不出源头，到处都是转帖，这里就不贴出相关网址了，baidu或Google下就知道了。</p>
<h4><strong>4、以一个实例说明C#中如何使用POST、GET等操作</strong></h4>
<p>在介绍实例之前，我们要先介绍一下HttpWebRequest和HttpWebResponse，在C#中就是用这两个类实现客户端向服务器端发送HTTP消息、客户端接受服务器端的HTTP响应。</p>
<h4><strong>4.1、HttpWebRequest</strong></h4>
<p>在设计实现实例之前我们首先要介绍一下HttpWebRequest这个类——提供<a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebRequest</a> 类的HTTP 特定的实现，HttpWebRequest类对WebRequest中定义的属性和方法提供支持，也对使用户能够直接与使用 HTTP 的服务器交互的附加属性和方法提供支持。</p>
<p>不要使用<a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.httpwebrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">HttpWebRequest</a> 构造函数。使用<a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest.create%28v=VS.80%29.aspx" rel="external nofollow noreferrer">System.Net.WebRequest.Create</a> 方法初始化新的 HttpWebRequest对象。如果统一资源标识符 (URI) 的方案是 http:// 或 https://，则 Create返回 HttpWebRequest对象。<br />
<br />HTTP消息的首部字段（headers），在HttpWebRequest中表示为公开的属性。下表列出了由属性或方法设置或由系统设置的 HTTP 标头。</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/%E9%A6%96%E9%83%A8%E5%AD%97%E6%AE%B5_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0LyVFOSVBNiU5NiVFOSU4MyVBOCVFNSVBRCU5NyVFNiVBRSVCNV90aHVtYi5wbmc=.jpg"></a></p>
<p>如果本地计算机配置指定使用代理，或者如果请求指定代理，则使用代理发送请求。如果未指定代理，则请求发送到服务器。</p>
<p>HttpWebRequest类主要包括如下方法，用于与HTTP服务器交互：</p>
<ul>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.abort%28v=VS.80%29.aspx" rel="external nofollow noreferrer">Abort</a>： 取消对 Internet 资源的请求。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.addrange%28v=VS.80%29.aspx" rel="external nofollow noreferrer">AddRange</a>： 向请求添加范围标头。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.begingetrequeststream%28v=VS.80%29.aspx" rel="external nofollow noreferrer">BeginGetRequestStream</a>：开始对用来写入数据的 <a href="http://msdn.microsoft.com/zh-cn/library/system.io.stream%28v=VS.80%29.aspx" rel="external nofollow noreferrer">Stream</a> 对象的异步请求。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.begingetresponse%28v=VS.80%29.aspx" rel="external nofollow noreferrer">BeginGetResponse</a>：开始对Internet 资源的异步请求。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest.create%28v=VS.80%29.aspx" rel="external nofollow noreferrer">Create</a>：初始化新的 <a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebRequest</a>。（从<a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebRequest</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest.createdefault%28v=VS.80%29.aspx" rel="external nofollow noreferrer">CreateDefault</a>：为指定的 URI 方案初始化新的 <strong>WebRequest</strong> 实例。（从<a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebRequest</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject.createobjref%28v=VS.80%29.aspx" rel="external nofollow noreferrer">CreateObjRef</a>：创建一个对象，该对象包含生成用于与远程对象进行通信的代理所需的全部相关信息。 （从<a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject%28v=VS.80%29.aspx" rel="external nofollow noreferrer">MarshalByRefObject</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/7de1x8cb%28v=VS.80%29.aspx" rel="external nofollow noreferrer">EndGetRequestStream</a>：结束对用于写入数据的 <strong>Stream</strong> 对象的异步请求。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.endgetresponse%28v=VS.80%29.aspx" rel="external nofollow noreferrer">EndGetResponse</a>：结束对 Internet 资源的异步请求。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/d4cek6cc%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetRequestStream</a>：获取用于写入请求数据的 <strong>Stream</strong> 对象。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.getresponse%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetResponse</a>：返回来自 Internet 资源的响应。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest.getsystemwebproxy%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetSystemWebProxy</a>：返回当前模拟用户的 Internet Explorer 设置中配置的代理。（从 <a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebRequest</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject.initializelifetimeservice%28v=VS.80%29.aspx" rel="external nofollow noreferrer">InitializeLifetimeService</a>：获取控制此实例的生存期策略的生存期服务对象。 （从 <a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject%28v=VS.80%29.aspx" rel="external nofollow noreferrer">MarshalByRefObject</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest.registerprefix%28v=VS.80%29.aspx" rel="external nofollow noreferrer">RegisterPrefix</a>：为指定的URI 注册<strong>WebRequest</strong> 子代。（从<a href="http://msdn.microsoft.com/zh-cn/library/system.net.webrequest%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebRequest</a> 继承。）</li>
</ul>
<h4><strong>4.2、HttpWebResponse</strong></h4>
<p>在设计实现实例之前我们还要介绍一下HttpWebRequest这个类——提供<a href="http://msdn.microsoft.com/zh-cn/library/system.net.webresponse%28v=VS.80%29.aspx" rel="external nofollow noreferrer">WebResponse</a> 类的HTTP 特定的实现。此类包含对WebResponse类中的属性和方法的 HTTP 特定用法的支持。HttpWebResponse类用于生成发送HTTP请求和接收HTTP响应的HTTP独立客户端应用程序。</p>
<blockquote><p>注意</p>
<p>不要混淆 <strong>HttpWebResponse</strong> 和 <a href="http://msdn.microsoft.com/zh-cn/library/system.web.httpresponse%28v=VS.80%29.aspx" rel="external nofollow noreferrer">HttpResponse</a> 类；后者用于 ASP.NET 应用程序，而且它的方法和属性是通过 ASP.NET 的内部 <strong>Response</strong> 对象公开的。</p></blockquote>
<p>决不要直接创建HttpWebResponse类的实例。而应当使用通过调用 <a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebrequest.getresponse%28v=VS.80%29.aspx" rel="external nofollow noreferrer">HttpWebRequest.GetResponse</a> 所返回的实例。您必须调用 <a href="http://msdn.microsoft.com/zh-cn/library/system.io.stream.close%28v=VS.80%29.aspx" rel="external nofollow noreferrer">Stream.Close</a> 方法或 <a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebresponse.close%28v=VS.80%29.aspx" rel="external nofollow noreferrer">HttpWebResponse.Close</a> 方法来关闭响应并将连接释放出来供重用。不必同时调用 <strong>Stream.Close</strong> 和 <strong>HttpWebResponse.Close</strong>，但这样做不会导致错误。</p>
<p>从 Internet 资源返回的公共标头信息公开为该类的属性。有关完整的列表，请参见下表。可以从 <a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebresponse.headers%28v=VS.80%29.aspx" rel="external nofollow noreferrer">Headers</a> 属性以名称/值对的形式读取其他标头。下表显示可以通过HttpWebResponse类的属性使用的公共 HTTP 标头。</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/%E9%A6%96%E9%83%A8%E5%AD%97%E6%AE%B51_2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0LyVFOSVBNiU5NiVFOSU4MyVBOCVFNSVBRCU5NyVFNiVBRSVCNTFfdGh1bWIucG5n.jpg"></a> 通过调用<a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebresponse.getresponsestream%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetResponseStream</a>方法，以<a href="http://msdn.microsoft.com/zh-cn/library/system.io.stream%28v=VS.80%29.aspx" rel="external nofollow noreferrer">Stream</a>的形式返回来自 Internet 资源的响应的内容。</p>
<p>HttpWebRequest类主要包括如下方法与HTTP服务器交互：（与HttpWebRequest类相比，方法较少）</p>
<ul>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject.createobjref%28v=VS.80%29.aspx" rel="external nofollow noreferrer">CreateObjRef</a>：创建一个对象，该对象包含生成用于与远程对象进行通信的代理所需的全部相关信息。（从<a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject%28v=VS.80%29.aspx" rel="external nofollow noreferrer">MarshalByRefObject</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject.getlifetimeservice%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetLifetimeService</a>：检索控制此实例的生存期策略的当前生存期服务对象。（从<a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject%28v=VS.80%29.aspx" rel="external nofollow noreferrer">MarshalByRefObject</a> 继承。）</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebresponse.getresponseheader%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetResponseHeader</a>：获取与响应一起返回的标头的内容。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.net.httpwebresponse.getresponsestream%28v=VS.80%29.aspx" rel="external nofollow noreferrer">GetResponseStream</a>：获取流，该流用于读取来自服务器的响应的体。</li>
<li><a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject.initializelifetimeservice%28v=VS.80%29.aspx" rel="external nofollow noreferrer">InitializeLifetimeService</a>：获取控制此实例的生存期策略的生存期服务对象。（从 <a href="http://msdn.microsoft.com/zh-cn/library/system.marshalbyrefobject%28v=VS.80%29.aspx" rel="external nofollow noreferrer">MarshalByRefObject</a> 继承。）</li>
</ul>
<h4><strong>4.3、编写WinForm程序打开博客园首页（附源码）</strong></h4>
<p>通过前面两小节的介绍，我们对HttpWebRequest类和HttpWebRequest类有所了解，现在我们就应用它们来编写一个小程序来实践。程序界面大概如下：</p>
<p><a href="http://images.cnblogs.com/cnblogs_com/skynet/WindowsLiveWriter/HTTPPOSTGET_C304/image_4.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3NreW5ldC9XaW5kb3dzTGl2ZVdyaXRlci9IVFRQUE9TVEdFVF9DMzA0L2ltYWdlX3RodW1iXzEucG5n.jpg"></a>功能也比较简单，就是通过点击“在WebBrowser中显示”按钮就在下方的 WebBrowser控件中显示博客园首页，通过点击查看“html源码”按钮就弹出一个对话框显示博客园首页的html源码。</p>
<p>首先我们介绍如何实现——通过点击查看“html源码”按钮就弹出一个对话框显示博客园首页的html源码。核心代码如下：</p>
<pre><code>       private string GetCnBlogs()
        {
            string html = String.Empty;
            HttpWebRequest cnbogs = (HttpWebRequest)System.Net.WebRequest.Create(txtURL.Text.ToString());
            cnbogs.Accept = "image/jpeg, application/x-ms-application, image/gif, application/xaml+xml, image/pjpeg, application/x-ms-xbap, application/x-shockwave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, application/QVOD, application/QVOD, */*";
            cnbogs.UserAgent = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; MALN; CIBA; InfoPath.2; .NET4.0C; .NET4.0E; Media Center PC 6.0; Tablet PC 2.0; AskTB5.6)";
            cnbogs.Method = "GET";

            HttpWebResponse cnblogsRespone = (HttpWebResponse)cnbogs.GetResponse();
            if (cnblogsRespone != null&amp;&amp;cnblogsRespone.StatusCode==HttpStatusCode.OK)
            {
                using(StreamReader sr = new StreamReader(cnblogsRespone.GetResponseStream()))
                {
                    html = sr.ReadToEnd();
                }
            }
            return html;
        }

        private void btnGetHtml_Click(object sender, EventArgs e)
        {
            MessageBox.Show(GetCnBlogs());
        }</code></pre>
<p>其实这个过程更我们通过在浏览器中输入博客园网站打开效果是一样的，只不过在这里我们是通过HttpWebRequest类和HttpWebRequest类的对象来实现的。</p>
<p>然而，通过点击“在WebBrowser中显示”按钮就在下方的<br />
WebBrowser控件中显示博客园首页的功能类似，只不过是在WebBrowser控件中显示且我这里把一些常用的HTTP相关的操作封装到一个命名<br />
空间Helper中，便于以后使用，本质跟上面的是一样的。<a href="http://files.cnblogs.com/skynet/LoginCnblogs.rar" rel="external nofollow noreferrer">点击</a>下载整个项目的源码。</p>
<p>我这个源码还是比较简陋，只是简单地实现了使用HttpWebRequest类和HttpWebRequest类与HTTP服务器交互，更完善的功能期待你去完成。</p>
<p> </p>
<p><strong>补充说明</strong>：关于url的长度限制问题，IE的url最长可以传 2083 字符（半角），而GET最多只能到2048字符。但是RFC 2616，Hypertext Transfer Protocol -- HTTP/1.1，并没有对url的最大长度做限制。 </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 06:30:31</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>HTTP协议及其POST与GET操作差异 &amp; C#中如何使用POST、GET等的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAWRkM.html" rel="bookmark">HTTP协议及其POST与GET操作差异 &amp;amp&semi;amp&semi; C&num;中如何使用POST、GET等</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来源: http://www.cnblogs.com/skynet/archive/2010/05/18/1738301.html   引言 HTTP协议我想任何IT人士都耳熟能详了,大家都能说出个所以然来.但是如果我问你HTTP协议的请求方法有哪些?POST与GET的差异?GET或POST传送数据量的大小有限制吗?HTTP响应的状态有哪些?以及在C#中你如何使用?如果你不能清楚地回答其中的大部分问题,那么这篇文章就是为你准备的!大纲如下: 1.HTTP概述 1.1.HTTP协议的客户端与服务器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWN1g7b.html" rel="bookmark">一起谈&period;NET技术，HTTP协议及POST与GET操作差异，C&num;中如何使用POST、GET等</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 HTTP协议我想任何IT人士都耳熟能详了,大家都能说出个所以然来.但是如果我问你HTTP协议的请求方法有哪些?POST与GET的差异?GET或POST传送数据量的大小有限制吗?HTTP响应的状态有哪些?以及在C#中你如何使用?如果你不能清楚地回答其中的大部分问题,那么这篇文章就是为你准备的!大纲如下: 1.HTTP概述 1.1.HTTP协议的客户端与服务器的交互 1.2.HTTP消息 1.3.HTTP请求的方法 1.4.HTTP响应的代码 2.抓包分析 3.POST与GET的差异 4.以一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWNnxAb.html" rel="bookmark">HTTP协议及POST与GET操作差异，C&num;中如何使用POST、GET等</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 HTTP协议我想任何IT人士都耳熟能详了,大家都能说出个所以然来.但是如果我问你HTTP协议的请求方法有哪些?POST与GET的差异?GET或POST传送数据量的大小有限制吗?HTTP响应的状态有哪些?以及在C#中你如何使用?如果你不能清楚地回答其中的大部分问题,那么这篇文章就是为你准备的!大纲如下: 1.HTTP概述1.1.HTTP协议的客户端与服务器的交互1.2.HTTP消息1.3.HTTP请求的方法1.4.HTTP响应的代码2.抓包分析3.POST与GET的差异4.以一个实例说明C#			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9vNjop.html" rel="bookmark">iOS 文件及字符串相关操作汇总 - 持续更新中&period;&period;&period;&period;&period;&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS 文件及字符串相关操作汇总 - 持续更新中...... 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&quot;创作公用协议 转载请保留此句:太阳火神的美丽人生 -  本博客专注于 敏捷开发及移动和物联设备研究:iOS.Android.Html5.Arduino.pcDuino,否则,出自本博客的文章拒绝转载或再转载,谢谢合作. 1.获取应用包中文件的绝对路径: NSString *absoluteFileNam			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8kXEoM.html" rel="bookmark">系统日志的编写-使用C&num;语言实现系统日志的记录，即把用户名及用户登录后的所有操作记录在数据库中。主要是怎么实</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 使用C#语言实现系统日志的记录,即把用户名及用户登录后的所有操作记录在数据库中.主要是怎么实 使用C#语言实现系统日志的记录,即把用户名及用户登录后的所有操作记录在数据库中.主要是怎么实现? 解决方案 有很多方法,比如直接就插入数据库,用aop日志框架,数据库用触发器等等. 解决方案二: 用log4Net就可以轻松实现你的要求!! 解决方案三: 是的,以上两种方法均可以,但是具体的点击某一个菜单,记录此操作的id等,有没有具体的代码实现的呀? 解决方案四: 建立一个日志表,使用inse			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR478b.html" rel="bookmark">用java来操作mongoDB&comma;备份mongDB中的数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 用java来操作mongoDB,备份mongDB中的数据 come on 大神 如题 现在想每个月把数据库中的数据导出来做备份 , 怎么用java语言来实现呢 ? 谢啦!!! 解决方案 omg 我在顶顶吧 解决方案二: 写一个quartz的定时任务管理, 然后创建一个机遇每月月初几点几分执行的任务... 然后就是执行你需要的业务逻辑,如果比较复杂的话,就使用异步来实现. 最后记得生成一份日志或者报表用于查看数据备份后的一些结果输出信息... 大致的思路是这样的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjwENVM.html" rel="bookmark">重新想象 Windows 8 Store Apps &lpar;24&rpar; - 文件系统&colon; Application Data 中的文件操作&comma; Package 中的文件操作&comma; 可移动存储中的文件操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:重新想象 Windows 8 Store Apps (24) - 文件系统: Application Data 中的文件操作, Package 中的文件操作, 可移动存储中的文件操作 [源码下载] 重新想象 Windows 8 Store Apps (24) - 文件系统: Application Data 中的文件操作, Package 中的文件操作, 可移动存储中的文件操作 作者:webabcd 介绍重新想象 Windows 8 Store Apps 之 文件系统 Applicatio			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44j2Yz.html" rel="bookmark">asp&period;net 操作iis7正在应用中使用程序方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp教程.net 操作iis7正在应用中使用程序方法 Microsoft.Web.Administration 命名空间里,增加了ServerManager.Site几个大类来操作IIS7. 下面是一些核心代码,可以直接使用  1)建立虚拟目录 建立虚拟目录时,默认使用&quot;Default Web Site&quot;,也就是默认建立在Default Web Site, CreateVdir需要两个参数:虚拟路径名称和实际的物理路径    public static bool  CreateVdi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYN8Qxp.html" rel="bookmark">winFrom 抓取屏幕指定区域 代码运行15分钟左右就出现（缓冲操作当前正在进行中，无法释放 BufferedGraphicsContext）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 由于项目需求每200毫秒抓取一次屏幕指定区域图像,但是程序运行15分钟左右就出现如下异常缓冲操作当前正在进行中,无法释放BufferedGraphicsContext以下代码在timer中每200毫秒执行一次,求高手帮助解决,在下不胜感激涕零!voidgetTargetPicTypeA(intx,inty,intw,inth){//创建图象,保存将来截取的图象Bitmapimage_s=newBitmap(w,h);GraphicsimgGraphics=Graphics.FromIm			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxZBz7.html" rel="bookmark" class="title">语音唤醒技术：small-footprint keyword spotting</a>
					<div>
						本文将介绍Interspeech 2017上关于语音唤醒技术的几篇文章. 相应分享视频链接:https://yq.aliyun.com/webinar/play/336 首先,什么是语音唤醒? 上面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAYvXM.html" rel="bookmark" class="title">Photoshop制作细腻逼真的古铜色沙漏</a>
					<div>
						制作之前最好对沙漏构造有全面的了解,每一个部件的特点.材质.光感等都要做到心中有数.然后画出每一部分的图形,再慢慢上色,刻画光影及材质即可. 最终效果 1.新建图层,参数如下. 2.矩形工具,前景色为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7W05z.html" rel="bookmark" class="title">从字符文档到xml文档</a>
					<div>
						xml     计算机世界尽管现在越来越多地试图使用unicode这一世界语来说话,但还是存在着gb2312,shift-jis这样的方言,使用MSXML DOM就会清楚地体会到方言的不便.    我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrOPmp.html" rel="bookmark" class="title">用户体验和网站优化方向的关系</a>
					<div>
						我的网站今天正式转入国内,过程中遇到了一些问题,在中文互联网资讯网站站长和wordpress博客博主以及空间商客服人员的帮助下,终于是告一段落了,速度明显快了一些,同时换成了和我的英文站一样的linu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w48Lp.html" rel="bookmark" class="title">Word Web App新增PDF文档阅读功能</a>
					<div>
						微软现在在打造云端服务的进度上可谓不遗余力,本周Word Web App网页版应用刚刚又加入了浏览PDF格式文档的功能.这为那些不愿掏钱购买完整版Office 2013套装的用户提供了更大的便利. 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwW03z.html" rel="bookmark" class="title">Office文档安全性问题：安全级别、数字签名、密码设置等</a>
					<div>
						文档也有安全性问题,尤其对于Office文档,为了让您的文档更安全,Office提供了比较完善的安全和文档保护功能,它包 括:安全级别.数字签名.密码设置.窗体保护和批注口令. 文档的安全级别 对Wo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKmeOp.html" rel="bookmark" class="title">Java线程：线程的调度-优先级</a>
					<div>
						线程的优先级用1-10之间的整数表示,数值越大优先级越高,默认的优先级为5. 在一个线程中开启另外一个新线程,则新开线程称为该线程的子线程,子线程初始优先级与父线程相同. /** * Java线程:线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOWaWM.html" rel="bookmark" class="title">Windows8系统新用户界面定名&OpenCurlyDoubleQuote;Windows UI&rdquo;</a>
					<div>
						电脑常识 距离微软正式发布Windows 8操作系统只有一天的时间了,你搞清楚Windows 8全新用户界面的定名了么?是New Windows UI?Windows 8-style UI?Moder ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPea7M.html" rel="bookmark" class="title">JavaScript中的splice&lpar;&rpar;方法使用详解</a>
					<div>
						  这篇文章主要介绍了JavaScript中的splice()方法使用详解,是JS入门学习中的基础知识,需要的朋友可以参考下 JavaScript数组的splice()方法改变数组的内容,增加了新的元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKZ9Np.html" rel="bookmark" class="title">分享XP系统实用的五个技巧</a>
					<div>
						分享XP系统实用的五个技巧   1.在记事本中自动记录文件的打开时间 在记事本中,我们可以记录每次打开某个文本文件的时间,方法为:在该文件的第一行输入&quot;.LOG&quot;(注意:必须大写! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY6KWM.html" rel="bookmark" class="title">如何在Excel2010批量求和的应用</a>
					<div>
						  有时候我们希望在Excel中将一些数据相加或者相乘得出它的和或积.在Excel中无论是求和还是求差都是非常方便的,而且准确无误.本次就来为大家详细讲解如何使用Excel2010批量求和的方法. E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP82Omp.html" rel="bookmark" class="title">win8系统在更新补丁蓝屏故障怎么办</a>
					<div>
						  每隔一段时间,咱们windows系统就会自动的推送一些补丁信息,咱们windows用户系统默认的也是自动更新的,因此,这些微软推送过的补丁信息会自动的在咱们的后台进行更新安装.但是似乎微软自己也没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjVvLb.html" rel="bookmark" class="title">win7开机黑屏只有鼠标解决方法</a>
					<div>
						  1.同时按下键盘Ctrl+Alt+Del(当然在此步骤前,首先要保证电脑连上了键盘),在列表中选择&quot;启动任务管理器&quot;,这是会弹出&quot;任务管理器&quot;,用鼠标点击左 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1e7xb.html" rel="bookmark" class="title">mac中osx lion 预览使用小技巧</a>
					<div>
						  预览功能是mac系统下面我们经常要用到的功能,当你查看一张照片时,打开一张图片时你就会用到它. Mac电脑的使用者在电脑后一开机后就可以轻松的享受到不用到处去寻找第三方的应用程式来打开各式各样类型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmJoVz.html" rel="bookmark" class="title">笔记本如何一键重装系统</a>
					<div>
						  目前电脑使用已经非常广泛了,那么遇见的电脑相关性的问题也会随之增加.比如说:电脑怎么重装系统呢?其实重装的方法莫非有两种.第一呢就是到你的电脑服务商那里让他们安装,去之前先打个电话,问问是否提供这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3vo3M.html" rel="bookmark" class="title">curl-求大神这个问题怎么解决resolving timed out after 15000 milliseconds</a>
					<div>
						问题描述 求大神这个问题怎么解决resolving timed out after 15000 milliseconds 安卓curl切换其他WIFI时报这个错误,哪位大神有思路,谢谢,着急 着急 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24QKBp.html" rel="bookmark" class="title">利用WP-NoExternalLinks插件让外链变文本</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 往往在网站的运营过程中为了达到更好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLavqWz.html" rel="bookmark" class="title">探索安卓中有意义的动画！</a>
					<div>
						ribot 致力于打造美好且充满意义的用户体验,在这一过程中,动画不可或缺. 在 Droidcon London 听完一场 激励人心的演讲之后, 笔者决定深入研究安卓动画.本文集中展示了其研究结果,希 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N288M.html" rel="bookmark" class="title">java-用JAVA HttpClient模拟登陆网站时登陆成功后网站重定向，请问一下 怎么解决？？？谢谢拉</a>
					<div>
						问题描述 用JAVA HttpClient模拟登陆网站时登陆成功后网站重定向,请问一下 怎么解决???谢谢拉 我觉得最有问题的地方就是我没有触发这个js事件 js的部分代码如下 通过这个JS代码我猜测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwKZ5M.html" rel="bookmark" class="title">海量存储之十八--一致性和高可用专题</a>
					<div>
						我们已经在上面的分析中,我们已经看到observer模型在多机场景下的问题,所以,paxos模型的目标就是解决这个问题,他解决这个问题的方法就是quorum模型. 我的目标是让大家能弄明白,掌握这些复 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YrvVM.html" rel="bookmark" class="title">用户 &amp;amp&semi;&num;39&semi;sa&amp;amp&semi;&num;39&semi; 登录失败。原因&colon; 该帐户被禁用。 &lpar;Microsoft SQL Server，错误&colon; 18470&rpar;</a>
					<div>
						解决方法:先用windows身份验证的方式登录进去,然后在'安全性'-'登录名'-右键单击'sa'-'属性',选择&quot;状态&quot;选项卡,登录选择&quot;启用&quot;,是否允许连接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PvJZp.html" rel="bookmark" class="title">cxf 返回一条数据时如何转化为json数组输出</a>
					<div>
						问题描述 cxf 返回一条数据时如何转化为json数组输出 我用cxf2.0 restful框架,返回多条数据时是有中括号包含着大括号的,但是返回一条数据时只有大括号,没有中括号,走的方法是一样的,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQ8ZVp.html" rel="bookmark" class="title">oracle 11g-oracle11g 查询语句优化</a>
					<div>
						问题描述 oracle11g 查询语句优化 求解:我有一条经常搜索的语句需要优化 select column1,column2||column3,column4,column5,column6,col ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YOZdM.html" rel="bookmark" class="title">有什么办法修改浏览器上网时显示的数据</a>
					<div>
						问题描述 请教一下,比如我支付宝里只有100块,但我想把它显示成1万块,每次加载支付宝这个网页让程序自动把显示的100块改成1万块显示,只是让它显示成1万块,我可以等网页加载完后手动修改标签里的内容, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRdW9b.html" rel="bookmark" class="title">展望Google短域名</a>
					<div>
						自从微博的短域名上线以后,后我就觉的&quot;短域名&quot;的优势不仅在节约字数,便于用户访问和牢记,不久的未来短域名一定会有更深远的价值体现出来.只怪自己敏感度太差,没有细细的往下进行&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKqj1b.html" rel="bookmark" class="title">azure- 哪位大虾有过在Azure上面部署Python&sol;Django的经验？ 会涉及到修改很多东西么？</a>
					<div>
						问题描述 哪位大虾有过在Azure上面部署Python/Django的经验? 会涉及到修改很多东西么? 请问哪位大虾有过在Azure上面部署Python/Django的经验? 会涉及到修改很多东西么? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRA9db.html" rel="bookmark" class="title">锐道与东华大学建立暑期实践合作关系</a>
					<div>
						6月27日上午,锐道与东华大学暑期时间合作启动仪式在陆家嘴软件园举行.东华大学黄教授带领暑期实践学生参加了启动仪式. 为了使学生能够顺利的完成从学生到社会人的转型,将所学知识学以致用.东华大学要求在校 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKQ3jz.html" rel="bookmark" class="title">操作系统概念学习笔记 16 内存管理&lpar;二&rpar; 段页</a>
					<div>
						操作系统概念学习笔记 16 内存管理 (二) 分页(paging) 分页(paging)内存管理方案允许进程的物理地址空间可以使非连续的.分页避免了将不同大小的内存块匹配到交换空间上(前面叙述的内存管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBEE4z.html" rel="bookmark" class="title">关于Mapinfo中多边形图元各角经纬度数据的查询问题</a>
					<div>
						问题描述 搜索一个移动通信小区的覆盖范围数据,其实际呈现的应该是一个不规则多边形,应该有多个拐点,但我查询的结果始终只有4个点,利用这四个点重新绘制的图层是一个正南北向的矩形,代码如下:SearchI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo9LwM.html" rel="bookmark" class="title">零市场预算的做活动</a>
					<div>
						有一次同行和我说他们的年度盛典活动有 600 万的预算,我当时很惊讶.我大概算了一算,在猫扑的 7 年里,我拿到的市场预算加起来好像 6000 块都没有,除了猫扑做活动经常用到的玩偶等周边,所以我说预 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
